VisimBox 1.0 VisimBox 3d simulation and visualisation ToolBox

- Main Page
- Packages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Properties
VisimBox.Renderer.VertexBuffer Class Reference

Base abstract class for vertexbuffers. More...

Inheritance diagram for VisimBox.Renderer.VertexBuffer:

List of all members.

## Public Member Functions
| VertexBuffer (ResourceUsage usage)
| Just setup buffer with specified usage)
| VertexBuffer (Type vertexType, int count, ResourceUsage usage=ResourceUsage.Static)
| Initializes buffer with specified number of basic elements without cache.
| VertexBuffer (Type vertexType, int count, bool usecache=false, ResourceUsage usage=ResourceUsage.Static)
| Initializes buffer with specified number of basic elements.
abstract void | BindBuffer ()
| Binds buffer to the renderer on default position (depending on the vertex format)
## Protected Member Functions
override void | CreateCache ()
| Creates cache.
| VertexBuffer (IVertex[] values, bool cache=false, bool useArrayAsCache=false, ResourceUsage usage=ResourceUsage.Static)
| Initialized vertex buffer from array of values.
| VertexBuffer (ICollection< IVertex > values, bool cache=false, ResourceUsage usage=ResourceUsage.Static)
| Constructs buffer from collection of values.
| VertexBuffer (IVertexArray values, bool cache=false, ResourceUsage usage=ResourceUsage.Static)
| Initialized buffer from Vertex array.
## Protected Attributes
VertexDescriptor | descriptor
Type | VertexType
## Properties
virtual VertexDescriptor | Descriptor`[get]`
| Descriptor for the used vertex.
override ResourceType | ResourceType`[get]`
| Generic type of the resource.

## Detailed Description

Base abstract class for vertexbuffers.

## Constructor & Destructor Documentation

VisimBox.Renderer.VertexBuffer.VertexBuffer | ( | ResourceUsage | usage | ) |

Just setup buffer with specified usage)

Parameters:

  usage |

VisimBox.Renderer.VertexBuffer.VertexBuffer | ( | Type | vertexType,
|  | int | count,
|  | ResourceUsage | usage = `ResourceUsage.Static`
| ) |  |

Initializes buffer with specified number of basic elements without cache.

Parameters:

  vertexType | Required type of vertex (needed for size checking)
  count | Count of elements
  usage | Usage of the buffer, default is static (create once)

VisimBox.Renderer.VertexBuffer.VertexBuffer | ( | Type | vertexType,
|  | int | count,
|  | bool | usecache = `false`,
|  | ResourceUsage | usage = `ResourceUsage.Static`
| ) |  |

Initializes buffer with specified number of basic elements.

Parameters:

  vertexType | Required type of vertex (needed for size checking)
  count | Count of elements
  usecache | If true, cache is constructed and used
  usage | Usage of the buffer, default is static (create once)

VisimBox.Renderer.VertexBuffer.VertexBuffer | ( | IVertex[] | values,
|  | bool | cache = `false`,
|  | bool | useArrayAsCache = `false`,
|  | ResourceUsage | usage = `ResourceUsage.Static`
| ) |  | `[protected]`

Initialized vertex buffer from array of values.

Parameters:

  values | Source values
  cache | If true, cache is constructed and used
  useArrayAsCache | If true, vertex buffer will store reference to the source array as cache (so any direct read/write from/to array will be reflected in cache. Note, automatically sets cache using to true!
  usage | Usage of the buffer, default is static (create once)

VisimBox.Renderer.VertexBuffer.VertexBuffer | ( | ICollection< IVertex > | values,
|  | bool | cache = `false`,
|  | ResourceUsage | usage = `ResourceUsage.Static`
| ) |  | `[protected]`

Constructs buffer from collection of values.

Parameters:

  values | Source values
  cache | If true, cache is constructed and used
  usage | Usage of the buffer, default is static (create once)

VisimBox.Renderer.VertexBuffer.VertexBuffer | ( | IVertexArray | values,
|  | bool | cache = `false`,
|  | ResourceUsage | usage = `ResourceUsage.Static`
| ) |  | `[protected]`

Initialized buffer from Vertex array.

Parameters:

  values | Source values
  cache | If true, cache is constructed and used
  useArrayAsCache | If true, hw buffer will store reference to the source array as cache (so any direct read/write from/to array will be reflected in cache. Note, automatically sets cache using to true!
  usage | Usage of the buffer, default is static (create once)

## Member Function Documentation

abstract void VisimBox.Renderer.VertexBuffer.BindBuffer | ( |  | ) | `[pure virtual]`

Binds buffer to the renderer on default position (depending on the vertex format)

Implements VisimBox.Renderer.IVertexBuffer.

Implemented in VisimRenderGL.GLVertexBuffer.

override void VisimBox.Renderer.VertexBuffer.CreateCache | ( |  | ) | `[protected, virtual]`

Creates cache.

Reimplemented from VisimBox.Renderer.HWBuffer< T >.

## Member Data Documentation

VertexDescriptor VisimBox.Renderer.VertexBuffer.descriptor`[protected]`

Type VisimBox.Renderer.VertexBuffer.VertexType`[protected]`

## Property Documentation

virtual VertexDescriptor VisimBox.Renderer.VertexBuffer.Descriptor`[get]`

Descriptor for the used vertex.

Implements VisimBox.Renderer.IVertexBuffer.

override ResourceType VisimBox.Renderer.VertexBuffer.ResourceType`[get]`

Generic type of the resource.

Reimplemented from VisimBox.Renderer.HWBuffer< T >.

The documentation for this class was generated from the following file:

- VertexBufffer.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events